"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.symbol.async-iterator.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.symbol.to-string-tag.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.array.slice.js");
require("core-js/modules/es.function.name.js");
require("core-js/modules/es.json.to-string-tag.js");
require("core-js/modules/es.math.to-string-tag.js");
require("core-js/modules/es.object.get-prototype-of.js");
require("core-js/modules/es.object.set-prototype-of.js");
require("core-js/modules/es.regexp.exec.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.json.stringify.js");
require("core-js/modules/es.object.assign.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.promise.js");
require("core-js/modules/es.string.ends-with.js");
require("core-js/modules/web.dom-collections.for-each.js");
var _express = _interopRequireDefault(require("express"));
var _bodyParser = _interopRequireDefault(require("body-parser"));
var _open = _interopRequireDefault(require("open"));
var _fs = _interopRequireDefault(require("fs"));
var _path = _interopRequireDefault(require("path"));
var _envfile = _interopRequireDefault(require("envfile"));
var _createFlowManifest = require("./create-flow-manifest");
var _os = _interopRequireDefault(require("os"));
var _child_process = require("child_process");
var _cors = _interopRequireDefault(require("cors"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; } // @ts-nocheck
var app = (0, _express.default)();
var PORT = 5007;
app.use(_bodyParser.default.json());
app.use((0, _cors.default)());

// Load environment variables
var envPath = _path.default.resolve(".env");
var env = _envfile.default.parseFileSync(envPath);

// Endpoint to receive form submission
app.post("/submit-form", /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(req, res) {
    var config;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _context.prev = 0;
          config = req.body;
          _context.next = 4;
          return saveConfig(config);
        case 4:
          res.status(200).json({
            message: "Data received successfully"
          });
          _context.next = 11;
          break;
        case 7:
          _context.prev = 7;
          _context.t0 = _context["catch"](0);
          console.error("Server error:", _context.t0);
          res.status(500).json({
            error: "Internal server error"
          });
        case 11:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[0, 7]]);
  }));
  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}());
var server = app.listen(PORT, /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
  return _regeneratorRuntime().wrap(function _callee2$(_context2) {
    while (1) switch (_context2.prev = _context2.next) {
      case 0:
        console.log("Server listening on port ".concat(PORT));
        _context2.next = 3;
        return (0, _open.default)("https://panel.ouisys.com/configs/strategies/manage");
      case 3:
      case "end":
        return _context2.stop();
    }
  }, _callee2);
})));
function processConfig(config) {
  var newExtraConfigObj = {
    scenariosConfig: config.scenario_config_name // Include scenariosConfig
  };

  // Handle default scenario and service
  if (config.scenario_config.default) {
    var _config$scenario_conf, _config$scenario_conf2;
    var defaultFlowConfig = (_config$scenario_conf = config.scenario_config) === null || _config$scenario_conf === void 0 || (_config$scenario_conf = _config$scenario_conf.default) === null || _config$scenario_conf === void 0 ? void 0 : _config$scenario_conf.flowConfig;
    var defaultFlow = (_config$scenario_conf2 = config.scenario_config) === null || _config$scenario_conf2 === void 0 || (_config$scenario_conf2 = _config$scenario_conf2.default) === null || _config$scenario_conf2 === void 0 || (_config$scenario_conf2 = _config$scenario_conf2.flow) === null || _config$scenario_conf2 === void 0 ? void 0 : _config$scenario_conf2.toLowerCase();
    newExtraConfigObj.defaultScenario = defaultFlowConfig.slug;
    newExtraConfigObj.defaultService = defaultFlowConfig.service;
    defaultFlowConfig.host = ""; // Remove host
    // flow based service and scenario based on default
    var slugKey = "".concat(defaultFlow, "Scenario");
    var serviceKey = "".concat(defaultFlow, "Service");
    if (defaultFlow === "moredir") {
      slugKey = "moRedirScenario";
      serviceKey = "moRedirService";
    }
    if (defaultFlow === "oneclick") {
      slugKey = "oneClickScenario";
      serviceKey = "oneClickService";
    }
    newExtraConfigObj[slugKey] = defaultFlowConfig.slug;
    newExtraConfigObj[serviceKey] = defaultFlowConfig.service;
  }

  // Iterate over each operator and prepare the extra config object
  Object.keys(config.scenario_config.operators).forEach(function (operatorKey) {
    var operator = config.scenario_config.operators[operatorKey];
    var flow = operator.flow.toLowerCase(); // Normalize flow names to lower case
    var slugKey = "".concat(flow, "Scenario");
    var serviceKey = "".concat(flow, "Service");
    if (flow === "moredir") {
      slugKey = "moRedirScenario";
      serviceKey = "moRedirService";
    }
    if (flow === "oneclick") {
      slugKey = "oneClickScenario";
      serviceKey = "oneClickService";
    }
    operator.flowConfig.host = ""; // Remove host

    // Add scenario and service to new config
    newExtraConfigObj[slugKey] = operator.flowConfig.slug;
    newExtraConfigObj[serviceKey] = operator.flowConfig.service;
  });

  // Return the transformed config and new extra config
  return {
    strategy: config.strategy,
    country: config.country,
    newExtraConfigObj: newExtraConfigObj,
    strategyConfigs: config.scenario_config
  };
}
function saveConfig(_x3) {
  return _saveConfig.apply(this, arguments);
}
function _saveConfig() {
  _saveConfig = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(config) {
    var _processConfig, strategy, country, newExtraConfigObj, strategyConfigs, updatedConfig, configJSON;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          _context3.prev = 0;
          // Process the raw configuration
          _processConfig = processConfig(config), strategy = _processConfig.strategy, country = _processConfig.country, newExtraConfigObj = _processConfig.newExtraConfigObj, strategyConfigs = _processConfig.strategyConfigs; // Create the final updated configuration
          updatedConfig = {
            strategy: strategy,
            country: country,
            strategyConfigs: strategyConfigs
          }; // Save the configuration to a JSON file
          configJSON = JSON.stringify(updatedConfig, null, 2);
          console.log(configJSON);
          _context3.next = 7;
          return _fs.default.promises.writeFile(_path.default.resolve("config.json"), configJSON, "utf8");
        case 7:
          // Update the .env file with the extracted values
          updateEnv(newExtraConfigObj, country, strategy);
          (0, _createFlowManifest.createManifest)();
          console.log("Configuration saved successfully.");
          setTimeout(function () {
            shutdownServer();
          }, 2000);
          _context3.next = 16;
          break;
        case 13:
          _context3.prev = 13;
          _context3.t0 = _context3["catch"](0);
          console.error("Error saving configuration:", _context3.t0);
        case 16:
        case "end":
          return _context3.stop();
      }
    }, _callee3, null, [[0, 13]]);
  }));
  return _saveConfig.apply(this, arguments);
}
function updateEnv(extraConfig, country, strategy) {
  // Preserve existing static values in env
  var staticEnv = {
    client: env.client,
    title: env.title,
    page: env.page
  };

  // Remove old flow-related keys
  var flowKeys = Object.keys(env).filter(function (key) {
    return key.endsWith("Scenario") || key.endsWith("Service") || key === "scenariosConfig";
  });
  flowKeys.forEach(function (key) {
    return delete env[key];
  });

  // Add new flow-related keys and dynamic values
  Object.assign(env, staticEnv, extraConfig, {
    country: country,
    strategy: strategy
  });

  // Write the updated env object back to the file immediately
  _fs.default.writeFileSync(envPath, _envfile.default.stringifySync(env), "utf8");
}
function shutdownServer() {
  console.log("Shutting down the server...");
  server.close(function () {
    console.log("Server has been shut down.");
    focusAppOnMac("Visual Studio Code");
  });
}
function focusAppOnMac(appName) {
  if (_os.default.platform() === "darwin") {
    var script = "tell application \"".concat(appName, "\" to activate");
    (0, _child_process.exec)("osascript -e '".concat(script, "'"), handleAppleScriptExec);
  }
}
function handleAppleScriptExec(error, stdout, stderr) {
  if (error) {
    console.error("Error focusing app:", error);
    return;
  }
  if (stderr) {
    console.error("AppleScript stderr:", stderr);
    return;
  }
  console.log("App has been focused:", stdout);
}